/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.datatypes;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '
 * <em><b>CDirection Kind</b></em>', and utility methods for working with
 * them. <!-- end-user-doc -->
 * 
 * @see com.ibm.etools.c.datatypes.DatatypesPackage#getCDirectionKind()
 * @model @generated
 */
public final class CDirectionKind extends AbstractEnumerator {
    /**
     * The '<em><b>Parameter</b></em>' literal value. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @see #PARAMETER_LITERAL
     * @model name="parameter"
     * @generated @ordered
     */
    public static final int PARAMETER = 0;

    /**
     * The '<em><b>Return</b></em>' literal value. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #RETURN_LITERAL
     * @model name="return"
     * @generated @ordered
     */
    public static final int RETURN = 1;

    /**
     * The '<em><b>Parameter</b></em>' literal object. <!-- begin-user-doc
     * -->
     * <p>
     * If the meaning of '<em><b>Parameter</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @see #PARAMETER
     * @generated @ordered
     */
    public static final CDirectionKind PARAMETER_LITERAL = new CDirectionKind(PARAMETER, "parameter");

    /**
     * The '<em><b>Return</b></em>' literal object. <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Return</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @see #RETURN
     * @generated @ordered
     */
    public static final CDirectionKind RETURN_LITERAL = new CDirectionKind(RETURN, "return");

    /**
     * An array of all the '<em><b>CDirection Kind</b></em>' enumerators.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private static final CDirectionKind[] VALUES_ARRAY = new CDirectionKind[] { PARAMETER_LITERAL, RETURN_LITERAL, };

    /**
     * A public read-only list of all the '<em><b>CDirection Kind</b></em>'
     * enumerators. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

    /**
     * Returns the '<em><b>CDirection Kind</b></em>' literal with the
     * specified name. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public static CDirectionKind get(String name) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            CDirectionKind result = VALUES_ARRAY[i];
            if (result.toString().equals(name)) {
                return result;
            }
        }
        return null;
    }

    /**
     * Returns the '<em><b>CDirection Kind</b></em>' literal with the
     * specified value. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public static CDirectionKind get(int value) {
        switch (value) {
        case PARAMETER:
            return PARAMETER_LITERAL;
        case RETURN:
            return RETURN_LITERAL;
        }
        return null;
    }

    /**
     * Only this class can construct instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private CDirectionKind(int value, String name) {
        super(value, name);
    }

} //CDirectionKind
