/**
 * <copyright>
 * </copyright>
 *
 * $Id: COBOL66Element.java,v 1.2 2004/10/21 21:57:45 akkina Exp $
 */
package com.ibm.etools.cobol;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>66 Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * COBOL66Element represents the COBOL 66 data level.
 * For example:
 * 01 DATA-GROUP  PIC 9.
 *      03 DATA1 VALUE 1.	
 *      03 DATA2 VALUE 2.
 *      03 DATA3 VALUE 3.
 * 66 SUB-DATA RENAMES DATA1 THROUGH DATA2.
 * 66 AKA-DATA3 RENAMES DATA3.
 * 
 * In this example SUB-DATA refers to contents in DATA1 and DATA2.
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.ibm.etools.cobol.COBOL66Element#getName <em>Name</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOL66Element#getStart <em>Start</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOL66Element#getEndOf <em>End Of</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOL66Element()
 * @model 
 * @generated
 */
public interface COBOL66Element extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Specifies the name or handle of the COBOL66Element.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOL66Element_Name()
	 * @model 
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOL66Element#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Start</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start</em>' reference.
	 * @see #setStart(COBOLElement)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOL66Element_Start()
	 * @model required="true"
	 * @generated
	 */
	COBOLElement getStart();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOL66Element#getStart <em>Start</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start</em>' reference.
	 * @see #getStart()
	 * @generated
	 */
	void setStart(COBOLElement value);

	/**
	 * Returns the value of the '<em><b>End Of</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>End Of</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>End Of</em>' reference.
	 * @see #setEndOf(COBOLElement)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOL66Element_EndOf()
	 * @model 
	 * @generated
	 */
	COBOLElement getEndOf();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOL66Element#getEndOf <em>End Of</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>End Of</em>' reference.
	 * @see #getEndOf()
	 * @generated
	 */
	void setEndOf(COBOLElement value);

} // COBOL66Element
