/**
 * <copyright>
 * </copyright>
 *
 * $Id: COBOL88Element.java,v 1.2 2004/10/21 21:57:45 akkina Exp $
 */
package com.ibm.etools.cobol;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>88 Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * COBOL88Element represents the COBOL 88 data level.  
 * For example:
 * 1 TESTX PIC .
 *    88 TRUEX VALUE 'T' 't'.   *(TRUEX has 2 values)
 *    88 FALSEX VALUE 'F' 'f'.     *(FALSEX has 2 values)
 * 
 * Where TRUEX and FALSEX are condition names for the TESTX variable if value equals ('T' or 't') or ('F' or 'f'), respectively.
 * So if TESTX = 'T' or 't' then TRUEX = TRUE and FALSEX = FALSE;
 * If TESTX = 'F' or 'f' then FALSEX = TRUE and TRUEX = FALSE;
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.ibm.etools.cobol.COBOL88Element#getName <em>Name</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOL88Element#getHas <em>Has</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOL88Element()
 * @model 
 * @generated
 */
public interface COBOL88Element extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Specifies the name or handle of the COBOL88Element.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOL88Element_Name()
	 * @model 
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOL88Element#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Has</b></em>' containment reference list.
	 * The list contents are of type {@link com.ibm.etools.cobol.COBOL88ElementValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Rationale for this multiplicity value:
	 * -- Since each COBOL88Element can contain multiple COBOL88ElementValues, we have the 1...* cardinality.  See documentation on the COBOL88ElementValue class for an example .
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Has</em>' containment reference list.
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOL88Element_Has()
	 * @model type="com.ibm.etools.cobol.COBOL88ElementValue" containment="true" required="true"
	 * @generated
	 */
	EList getHas();

} // COBOL88Element
