/**
 * <copyright>
 * </copyright>
 *
 * $Id: COBOLTruncValue.java,v 1.2 2004/10/21 21:57:45 akkina Exp $
 */
package com.ibm.etools.cobol;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Trunc Value</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * The Trunc option determines whether decimal picture constraints must be honored for binary data items.
 * 
 * Values for Trunc are:
 * STD, OPT, and BIN
 * 
 * TRUNC(STD) conforms to the COBOL 85 Standard, while TRUNC(OPT) and 
 * TRUNC(BIN) are IBM extensions. 
 * 
 * For more information on the Trunc attribute, please refer to "COBOL/VSE Programming Guide"
 * 
 * trunc is a compiler option.  The available options for trunc are STD, OPT, and BIN.  More details about trunc can be found on: http://w3.enterlib.ibm.com/cgi-bin/bookmgr/BOOKS/igyva002/3.2.2.44?ACTION=MATCHES&REQUEST=trunc&TYPE=FUZZY&searchTopic=TOPIC&searchText=TEXT&searchIndex=INDEX&rank=RANK&ScrollTOP=FIRSTHIT#FIRSTHIT
 * but for now I think all you need to know is that it comes from the compiler option.
 * <!-- end-model-doc -->
 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLTruncValue()
 * @model
 * @generated
 */
public final class COBOLTruncValue extends AbstractEnumerator {
	/**
	 * The '<em><b>STD</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STD_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int STD = 0;

	/**
	 * The '<em><b>OPT</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #OPT_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int OPT = 1;

	/**
	 * The '<em><b>BIN</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BIN_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int BIN = 2;

	/**
	 * The '<em><b>STD</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>STD</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STD
	 * @generated
	 * @ordered
	 */
	public static final COBOLTruncValue STD_LITERAL = new COBOLTruncValue(STD, "STD");

	/**
	 * The '<em><b>OPT</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>OPT</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #OPT
	 * @generated
	 * @ordered
	 */
	public static final COBOLTruncValue OPT_LITERAL = new COBOLTruncValue(OPT, "OPT");

	/**
	 * The '<em><b>BIN</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>BIN</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #BIN
	 * @generated
	 * @ordered
	 */
	public static final COBOLTruncValue BIN_LITERAL = new COBOLTruncValue(BIN, "BIN");

	/**
	 * An array of all the '<em><b>Trunc Value</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final COBOLTruncValue[] VALUES_ARRAY =
		new COBOLTruncValue[] {
			STD_LITERAL,
			OPT_LITERAL,
			BIN_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>Trunc Value</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Trunc Value</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static COBOLTruncValue get(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			COBOLTruncValue result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Trunc Value</b></em>' literal with the specified value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static COBOLTruncValue get(int value) {
		switch (value) {
			case STD: return STD_LITERAL;
			case OPT: return OPT_LITERAL;
			case BIN: return BIN_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private COBOLTruncValue(int value, String name) {
		super(value, name);
	}

} //COBOLTruncValue
