// ****************************************************************
//
//   IBM Confidential
//   OCO Source Materials
//   <<PART NUMBER - 5724-B75>>
//   (C) Copyright IBM Corp. 2001 - All Rights Reserved.
//   US Government Users Restricted Rights - Use, duplication or disclosure
//   restricted by GSA ADP Schedule Contract with IBM Corp.
//
// ****************************************************************

package com.ibm.etools.cobol.importer;


import com.ibm.etools.cobol.plugin.CobolPlugin;

/**
 * This type handles the resources for this package.
 */
public class CobolResource 
{
	private static String copyright = "(c) Copyright IBM Corporation 1998, 1999.";
	//Locates the resource bundle used.	
//	private static java.util.ResourceBundle res = java.util.ResourceBundle.getBundle("com.ibm.etools.cobol.importer.CobolResourceBundle");
	
/**
 * This method ensures that the correct new line character is used for strings used with output.
 * Assumes that \n is the character used to force a new line in the input string.
 * @return java.lang.String The corrected string
 * @param tmpStr java.lang.String Input string.
 */
private static String correctString(String tmpStr) {
	 int index = 0;
	 int currentIndex = 0;
	 // Return tmpStr if it does not occur in the string.
	 if ((index = tmpStr.indexOf("\n")) == -1)
	 	return tmpStr;
	 
	 StringBuffer strBuf = new StringBuffer();
	 while (index != -1) {
		 strBuf.append(tmpStr.substring(currentIndex, index));
		 strBuf.append(System.getProperty("line.separator"));
		 currentIndex = index + 1;
		 index = tmpStr.indexOf("\n",currentIndex);
	 }
	 strBuf.append(tmpStr.substring(currentIndex,tmpStr.length()));
	 return strBuf.toString();	

}
/**
 * This method displays the string to the user. 
 * @param aMessage The text to be displayed.
 */
public static void display (String aMessage) 
{
//	System.err.println(aMessage + System.getProperty("line.separator"));
	CobolPlugin.write(CobolSourceImporter.instance(), "COBOL plugin", CobolPlugin.ERROR, aMessage);

	return;
}
/**
 * This method returns the localized string associated to the parameter.
 * @param key The key used to search for the localized message.
 * @return The localized string.
 */
public static String getString(String key) {
//	return correctString(res.getString(key));

	key = "%" + key;
	return correctString(CobolPlugin.getResource(key));
}
/**
 * This method returns the localized string modified with the array of objects.
 * @param key The key used to search for the localized message.
 * @param args The array of objects that are to be incorporated into the localized string.
 * @return The localized string text.
 */
 
public static String getString(String key, Object[] args) {
//	return java.text.MessageFormat.format(correctString(res.getString(key)), args);

	key = "%" + key;
	return correctString(CobolPlugin.getResource(key, args));
}
}
