// ****************************************************************
//
//   IBM Confidential
//   OCO Source Materials
//   <<com.ibm.etools.cobol>>
//   (C) Copyright IBM Corp. 2002, 2003,2004 - All Rights Reserved.
//   US Government Users Restricted Rights - Use, duplication or disclosure
//   restricted by GSA ADP Schedule Contract with IBM Corp.
//
// ****************************************************************
package com.ibm.etools.cobol.importer;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.io.*;
import java.util.Vector;
import com.ibm.etools.cobol.plugin.CobolPlugin;
import com.ibm.etools.logging.util.Level;

public class ErrorMsgs extends DefaultHandler{

	protected Vector cmpMsgResourceVector;
	protected Vector cmpMsgNumberVector;
	protected Vector cmpMsgLineVector;
	protected Vector cmpMsgColumnVector;
	protected Vector cmpMsgFileVector;
	protected Vector cmpMsgTextVector;
    String messageResourceBuffer;
    String messageNumberBuffer;
    String messageLineBuffer;
    String messageFileBuffer;
    String messageColumnBuffer;
    String messageTextBuffer;
    String plimessageResourceBuffer;
    String plimessageNumberBuffer;
    String plimessageLineBuffer;
    String plimessageFileBuffer;
    String plimessageFileNameBuffer;
    String plimessageColumnBuffer;
    String plimessageTextBuffer;


	public static void main(String[] arguments) {
		ErrorMsgs parsedOutput = new ErrorMsgs();
        parsedOutput.read(arguments[0]);
		
		String xResource;
		String xMsgNumber;
		int xMsgLine;
		int xMsgColumn;
		String xMsgFile;
		String xMsgText;
		parsedOutput.cmpMsgNumberVector = parsedOutput.getCmpMsgNumberVector();
		parsedOutput.cmpMsgLineVector = parsedOutput.getCmpMsgLineVector();
		parsedOutput.cmpMsgColumnVector = parsedOutput.getCmpMsgColumnVector();
		parsedOutput.cmpMsgFileVector = parsedOutput.getCmpMsgFileVector();
		parsedOutput.cmpMsgTextVector = parsedOutput.getCmpMsgTextVector();

		for (int vi = 0; vi < parsedOutput.cmpMsgNumberVector.size(); vi++) {
			xMsgNumber = (String) parsedOutput.cmpMsgNumberVector.elementAt(vi);
			xMsgLine = ((Integer) parsedOutput.cmpMsgLineVector.elementAt(vi)).intValue();
			xMsgColumn = ((Integer) parsedOutput.cmpMsgColumnVector.elementAt(vi)).intValue();
			xMsgFile = (String) parsedOutput.cmpMsgFileVector.elementAt(vi);
			xMsgText = (String) parsedOutput.cmpMsgTextVector.elementAt(vi);
			System.out.println("************************************************"); //$NON-NLS-1$
			System.out.println("2 File       :" + xMsgFile); //$NON-NLS-1$
			System.out.println("2 MsgNumber:" + xMsgNumber); //$NON-NLS-1$
			System.out.println("2 LineNumber :" + xMsgLine); //$NON-NLS-1$
			System.out.println("2 ColNumber  :" + xMsgColumn); //$NON-NLS-1$
			System.out.println("2 MessageTxt :" + xMsgText); //$NON-NLS-1$
			System.out.println("************************************************"); //$NON-NLS-1$
		}

	}
	
	/////////////////////////////////////////////
	
	public void read(String compilerXMLFile) {

		File input = new File(compilerXMLFile);
		SAXParserFactory factory = SAXParserFactory.newInstance();
		factory.setValidating(false);
		try {
			SAXParser sax = factory.newSAXParser();
			StringBuffer sb = new StringBuffer();
			BufferedInputStream bis = new BufferedInputStream(new FileInputStream(compilerXMLFile));
			byte[] buf = new byte[4 * 1024]; // 4K buffer
			int bytesRead;
			while ((bytesRead = bis.read(buf)) != -1) {
				byte[] b = new byte[bytesRead];
				int i = 0;
				for (int j = 0; j < bytesRead; j++) {
					if (buf[j] != 0x1e && buf[j] != 0x1f) {
						b[i] = buf[j];
						i++;
					}
				}
				sb.append(new String(b, 0, i, "UTF-8")); //$NON-NLS-1$
			}
			bis.close(); //close the Buffered Input Stream
			if(sb.length() != 0 ){
				InputStream is = new ByteArrayInputStream(sb.toString().getBytes("UTF-8")); //$NON-NLS-1$			
				sax.parse(is, this);					
				is.close();
			}	
		} catch (ParserConfigurationException pce) {
			CobolPlugin.getPlugin().writeMsg(Level.SEVERE,"*** ErrorMsgs.read(String): Could not create that parser.: " + pce.getMessage(), pce); 
		} catch (SAXException se) {
			CobolPlugin.getPlugin().writeMsg(Level.SEVERE,"*** ErrorMsgs.read(String): Problem with the SAX parser.: " + se.getMessage(), se);  
		} catch (IOException ioe) {
			CobolPlugin.getPlugin().writeMsg(Level.SEVERE,"*** ErrorMsgs.read(String): Error reading file.: " + ioe.getMessage(), ioe); 
		}	
	}
	
	public Vector getCmpMsgResourceVector() {
		return cmpMsgResourceVector;
	}	
	public Vector getCmpMsgNumberVector() {
		return cmpMsgNumberVector;
	}
	public Vector getCmpMsgLineVector() {
		return cmpMsgLineVector;
	}
	public Vector getCmpMsgColumnVector() {
		return cmpMsgColumnVector;
	}
	public Vector getCmpMsgFileVector() {
		return cmpMsgFileVector;
	}
	public Vector getCmpMsgTextVector() {
		return cmpMsgTextVector;
	}
	
///////////////////////////////////////////////
static int READING_BUILD = 1;
	static int READING_PACKAGE = 2;
	static int READING_FILEREFERENCETABLE= 3;
	static int READING_FILECOUNT = 4;
	static int READING_FILE = 5;
	static int READING_FILENUMBER = 6;
	static int READING_FILENAME = 7;
	static int READING_INCLUDEDFROMFILE = 8;
	static int READING_INCLUDEDONLINE = 9;
	static int READING_MESSAGE = 10;
	static int READING_MSGNUMBER = 11;
	static int READING_MSGCOLUMN = 12;
	static int READING_MSGLINE = 13;
	static int READING_MSGFILE = 14;
	static int READING_MSGTEXT = 15;
	static int READING_CBLRESOURCE = 16;
	static int READING_CBLMESSAGE = 17;
	static int READING_CBLFILENAME = 18;
	static int READING_CBLLINENUMBER = 19;
	static int READING_CBLCOLUMNNUMBER = 20;
	static int READING_CBLMSGID = 21;
	static int READING_CBLMSGTXT = 22;
	static int READING_NOTHING = 0;

	int currentActivity = READING_NOTHING;

	String xmlBUILDTag = "Build"; //$NON-NLS-1$
	String xmlPACKAGETag = "package"; //$NON-NLS-1$
	String xmlFILEREFERENCETABLETag = "FileReferenceTable"; //$NON-NLS-1$
	String xmlFILECOUNTTag = "FileCount"; //$NON-NLS-1$
	String xmlFILETag = "File"; //$NON-NLS-1$
	String xmlFILENUMBERTag = "FileNumber"; //$NON-NLS-1$
	String xmlFILENAMETag = "FileName"; //$NON-NLS-1$
	String xmlINCLUDEDFROMFILETag = "IncludedFromFile"; //$NON-NLS-1$
	String xmlINCLUDEDONLINETag = "IncludedOnLine"; //$NON-NLS-1$
	String xmlMESSAGETag = "message"; //$NON-NLS-1$
	String xmlMSGNUMBERTag = "msgNumber"; //$NON-NLS-1$
	String xmlMSGCOLUMNTag = "msgColumn"; //$NON-NLS-1$
	String xmlMSGLINETag = "msgLine"; //$NON-NLS-1$
	String xmlMSGFILETag = "msgFile"; //$NON-NLS-1$
	String xmlMSGTEXTTag = "msgText"; //$NON-NLS-1$
	String xmlCBLRESOURCETag = "CBLResource"; //$NON-NLS-1$
	String xmlCBLMESSAGETag = "CBLMessage"; //$NON-NLS-1$
	String xmlCBLFILENAMETag = "CBLFilename"; //$NON-NLS-1$
	String xmlCBLLINENUMBERTag = "CBLLinenumber"; //$NON-NLS-1$
	String xmlCBLCOLUMNNUMBERTag = "CBLColumnnumber"; //$NON-NLS-1$
	String xmlCBLMSGIDTag = "CBLMsgID"; //$NON-NLS-1$
	String xmlCBLMSGTXTTag = "CBLMsgtxt"; //$NON-NLS-1$

   boolean visitedMSGLINE = false;
   boolean visitedMSGFILE = false;
	protected Vector x1FileNameVector;
	// protected Vector xResourceVector;


	public ErrorMsgs() {
		super();
	}

	public void startDocument() {

		//  x1FileNameVector; gets a new vector in throughout the course of parsing
		cmpMsgResourceVector = new Vector();
		cmpMsgNumberVector = new Vector();
		cmpMsgLineVector = new Vector();
		cmpMsgColumnVector = new Vector();
		cmpMsgFileVector = new Vector();
		cmpMsgTextVector = new Vector();
		messageResourceBuffer = "";
		messageNumberBuffer = "";
		messageLineBuffer = "";
		messageFileBuffer = "";
		messageColumnBuffer = "";
		messageTextBuffer = "";
		plimessageResourceBuffer = "";
		plimessageNumberBuffer = "";
		plimessageLineBuffer = "";
		plimessageFileBuffer = "";
		plimessageFileNameBuffer = "";
		plimessageColumnBuffer = "";
		plimessageTextBuffer = "";
		
	}
	public void startElement(
		String uri,
		String qName,
		String localName,
		Attributes attributes) {

        CobolPlugin.getPlugin().writeMsg(Level.FINE,"*** ErrorMsgs.startElement(String, String, String, Attributes): Start of Element: " + localName);         						
		if (localName.equals(xmlBUILDTag))
			currentActivity = READING_BUILD;

		else if (localName.equals(xmlPACKAGETag))
			currentActivity = READING_PACKAGE;

		else if (localName.equals(xmlFILEREFERENCETABLETag)) {
			//create a new vector for a new set of FILENAMES for pli.  The filename that refers to
			//filenumber 1 should be in the number 1 slot, fill the number 0 slot with xxx
			currentActivity = READING_FILEREFERENCETABLE;
			x1FileNameVector = new Vector();
			x1FileNameVector.addElement("xxx"); //fill the 0 spot //$NON-NLS-1$
		} else if (localName.equals(xmlFILECOUNTTag))
			currentActivity = READING_FILECOUNT;

		else if (localName.equals(xmlFILETag))
			currentActivity = READING_FILE;

		else if (localName.equals(xmlFILENUMBERTag))
			currentActivity = READING_FILENUMBER;

		else if (localName.equals(xmlFILENAMETag))
			currentActivity = READING_FILENAME;

		else if (localName.equals(xmlINCLUDEDFROMFILETag))
			currentActivity = READING_INCLUDEDFROMFILE;

		else if (localName.equals(xmlINCLUDEDONLINETag))
			currentActivity = READING_INCLUDEDONLINE;

		else if (localName.equals(xmlMESSAGETag))
			currentActivity = READING_MESSAGE;

		else if (localName.equals(xmlMSGNUMBERTag))
			currentActivity = READING_MSGNUMBER;

		else if (localName.equals(xmlMSGCOLUMNTag))
			currentActivity = READING_MSGCOLUMN;

		else if (localName.equals(xmlMSGLINETag))
			currentActivity = READING_MSGLINE;

		else if (localName.equals(xmlMSGFILETag))
			currentActivity = READING_MSGFILE;

		else if (localName.equals(xmlMSGTEXTTag))
			currentActivity = READING_MSGTEXT;

		else if (localName.equals(xmlCBLRESOURCETag))
			currentActivity = READING_CBLRESOURCE;

		else if (localName.equals(xmlCBLMESSAGETag))
			currentActivity = READING_CBLMESSAGE;

		else if (localName.equals(xmlCBLFILENAMETag))
			currentActivity = READING_CBLFILENAME;

		else if (localName.equals(xmlCBLLINENUMBERTag))
			currentActivity = READING_CBLLINENUMBER;

		else if (localName.equals(xmlCBLCOLUMNNUMBERTag))
			currentActivity = READING_CBLCOLUMNNUMBER;

		else if (localName.equals(xmlCBLMSGIDTag))
			currentActivity = READING_CBLMSGID;

		else if (localName.equals(xmlCBLMSGTXTTag))
			currentActivity = READING_CBLMSGTXT;

	}

	public void characters(char[] ch, int start, int length) {
		String value = new String(ch, start, length);
		char ch1 = ch[start];
		boolean skip = false;
        CobolPlugin.getPlugin().writeMsg(Level.FINE,"*** ErrorMsgs.characters(char[], int, int): characters = " + value);
		if (length < 1) {
            CobolPlugin.getPlugin().writeMsg(Level.FINE,"*** ErrorMsgs.characters(char[], int, int): zero length");			
			skip = true;
		}
		if (length == 1) {
			if (Character.isSpaceChar(ch1)) {
				skip = true;
			}
			if (ch1 == '\n') {
   		        CobolPlugin.getPlugin().writeMsg(Level.FINE,"*** ErrorMsgs.characters(char[], int, int): backslash n");							
				skip = true;
			}
			if (ch1 == '\r') {
   		        CobolPlugin.getPlugin().writeMsg(Level.FINE,"*** ErrorMsgs.characters(char[], int, int): backslash r");							
				skip = true;
			}

		}
		if (!skip) {
			if (currentActivity == READING_FILENAME) {
				plimessageFileNameBuffer += value;
				plimessageResourceBuffer += value;
				//x1FileNameVector.addElement(value);
				//cmpMsgResourceVector.addElement(value);
			}

			if (currentActivity == READING_MSGNUMBER)
			{
				plimessageNumberBuffer += value;
				//cmpMsgNumberVector.addElement(value);
			}

			if (currentActivity == READING_MSGLINE) {
				plimessageLineBuffer += value;
				
			}
			if (currentActivity == READING_MSGFILE) {
				
				plimessageFileBuffer += value;
				//change the filenumber to an actual name found in the FileName vector
			}

			if (currentActivity == READING_MSGTEXT)
			{
				plimessageTextBuffer += value;
				//cmpMsgTextVector.addElement(value);
//mef@stl 11/14/2002 - This fix is for COBOL only, problem doesn't occur in PL/I
//Don't know where the xml is broken up.  Need to keep buffers, and then
//when the tag has ended add the buffer values to the vectors
			}
			if (currentActivity == READING_CBLRESOURCE)
			{
                messageResourceBuffer += value;			
			}

			if (currentActivity == READING_CBLFILENAME)
			{
                messageFileBuffer += value;			
			}

			if (currentActivity == READING_CBLLINENUMBER) {
				
				messageLineBuffer += value;

			}
			if (currentActivity == READING_CBLCOLUMNNUMBER) {
				
				messageColumnBuffer += value;

			}
			if (currentActivity == READING_CBLMSGID){
				
				messageNumberBuffer += value;

			}

			if (currentActivity == READING_CBLMSGTXT)
			{
			  messageTextBuffer += value;			
			
			}
		} //if ! skip

	}

	public void endElement(String uri, String qName, String localName) {
        CobolPlugin.getPlugin().writeMsg(Level.FINE,"*** ErrorMsgs.endElement(String, String, String): Ending Element: " + localName);									
		String tempstr = "Not Important"; //$NON-NLS-1$
		if (localName.equals(xmlMESSAGETag))
			{
          if (!visitedMSGLINE)
             {
      			int TempInt=1;
      			Integer lineNumberIntObject = new Integer(TempInt);
      			cmpMsgLineVector.addElement(lineNumberIntObject);
      			TempInt=2;
      			Integer columnNumberIntObject = new Integer(TempInt);
      			cmpMsgColumnVector.addElement(columnNumberIntObject);
             }
          if (!visitedMSGFILE)
             {
              cmpMsgFileVector.addElement(x1FileNameVector.elementAt(1));
             }
          visitedMSGFILE=false;
          visitedMSGLINE=false;
         }
		if (localName.equals(xmlFILENAMETag))
			{
				x1FileNameVector.addElement(plimessageFileNameBuffer);
				cmpMsgResourceVector.addElement(plimessageResourceBuffer);
				plimessageFileNameBuffer = "";
				plimessageResourceBuffer = "";
				
             }
		if (localName.equals(xmlMSGNUMBERTag))
			{
				
				cmpMsgNumberVector.addElement(plimessageNumberBuffer);
				plimessageNumberBuffer = "";
             }
		if (localName.equals(xmlMSGLINETag))
			{
				
				int TempInt;
				TempInt = strToInt(plimessageLineBuffer);
				Integer lineNumberIntObject = new Integer(TempInt);
				cmpMsgLineVector.addElement(lineNumberIntObject);
				//no PL/I column number force it to column 2.
				TempInt = 2;
				Integer columnNumberIntObject = new Integer(TempInt);
				cmpMsgColumnVector.addElement(columnNumberIntObject);
                visitedMSGLINE = true; //mef@stl check this, because there are msgs w/o
                                   //msg files associated
                plimessageLineBuffer = "";
				
             }
		if (localName.equals(xmlMSGFILETag))
			{
        				//change the filenumber to an actual name found in the FileName vector
				
				int TempInt;
				TempInt = strToInt(plimessageFileBuffer);
				cmpMsgFileVector.addElement(x1FileNameVector.elementAt(TempInt));
                visitedMSGFILE = true; //mef@stl check this, because there are msgs w/o
                                   //msg files associated
                plimessageFileBuffer = "";
			}
		if (localName.equals(xmlMSGTEXTTag))
			{
					cmpMsgTextVector.addElement(plimessageTextBuffer);
					plimessageTextBuffer = "";
			}
/********************************************************/          
		if (localName.equals(xmlCBLRESOURCETag))
			{
				cmpMsgResourceVector.addElement(messageResourceBuffer.trim());
				messageResourceBuffer = "";
				
             }
          
		if (localName.equals(xmlCBLMSGIDTag))
			{
				cmpMsgNumberVector.addElement(messageNumberBuffer.trim());
				messageNumberBuffer = "";
				
             }
		if (localName.equals(xmlCBLFILENAMETag))
			{
				cmpMsgFileVector.addElement(messageFileBuffer.trim());
				messageFileBuffer = "";
				
             }
          
		if (localName.equals(xmlCBLLINENUMBERTag))
			{
                //messageLineBuffer has the line number as a string				
				int TempInt;
				TempInt = strToInt(messageLineBuffer.trim());
				Integer lineNumberIntObject = new Integer(TempInt);
				cmpMsgLineVector.addElement(lineNumberIntObject);
				messageLineBuffer = "";
				
             }
          
		if (localName.equals(xmlCBLCOLUMNNUMBERTag))
			{
				//messageColumnBuffer has the column number as a string
				int TempInt;
				TempInt = strToInt(messageColumnBuffer.trim());
				Integer columnNumberIntObject = new Integer(TempInt);
				cmpMsgColumnVector.addElement(columnNumberIntObject);				
				messageColumnBuffer = "";
				
             }
          
		if (localName.equals(xmlCBLMSGTXTTag))
			{
				cmpMsgTextVector.addElement(messageTextBuffer.trim());
				messageTextBuffer = "";
				
             }
		currentActivity = READING_NOTHING;
	}

	public void endDocument() {
		String xResource;
		String xMsgNumber;
		int xMsgLine;
		int xMsgColumn;
		String xMsgFile;
		String xMsgText;
		for (int vi = 0; vi < cmpMsgResourceVector.size(); vi++) {
			xResource = (String) cmpMsgResourceVector.elementAt(vi);
            CobolPlugin.getPlugin().writeMsg(Level.FINE,"*** ErrorMsgs.endDocument(....): Resource: " + xResource);					
		}

		for (int vi = 0; vi < cmpMsgTextVector.size(); vi++) {
			xMsgNumber = (String) cmpMsgNumberVector.elementAt(vi);
			xMsgLine = ((Integer) cmpMsgLineVector.elementAt(vi)).intValue();
			xMsgColumn = ((Integer) cmpMsgColumnVector.elementAt(vi)).intValue();
			xMsgFile = (String) cmpMsgFileVector.elementAt(vi);
			xMsgText = (String) cmpMsgTextVector.elementAt(vi);
            CobolPlugin.getPlugin().writeMsg(Level.FINE,"*** ErrorMsgs.endDocument(....): File       :" + xMsgFile);					
            CobolPlugin.getPlugin().writeMsg(Level.FINE,"*** ErrorMsgs.endDocument(....): MsgNumber:" + xMsgNumber);					
            CobolPlugin.getPlugin().writeMsg(Level.FINE,"*** ErrorMsgs.endDocument(....): ColNumber  :" + xMsgColumn);					
            CobolPlugin.getPlugin().writeMsg(Level.FINE,"*** ErrorMsgs.endDocument(....): MessageTxt :" + xMsgText);					            
		}


	}

	public int strToInt(String passedString) {
		/*change the string to an int*/
		StringBuffer revStrNumberBuff = new StringBuffer(passedString);
		String revStrNumber = new String(revStrNumberBuff.reverse());
		int xnum = 0;
		int xaccum = 0;
		int xplaces = 1;
		for (int j = 0; j < revStrNumber.length(); j++) {
			Character NumberChar = new Character(revStrNumber.charAt(j));
			//char after 1st paren
			xnum = Character.digit(NumberChar.charValue(), 10);
			xnum = xnum * xplaces;
			xaccum = xaccum + xnum;
			xplaces = xplaces * 10;
		}
		return (xaccum);
	}
}